defmodule Lytedev.Application do
  @moduledoc false

  use Application
  require Logger

  def start(type, args) do
    Logger.info(inspect({type, args}))
    Supervisor.start_link(children(), strategy: :one_for_one, name: Lytedev.Supervisor)
  end

  def config_change(changed, new, removed) do
    %{changed: changed, new: new, removed: removed}
    |> inspect()
    |> Logger.info(printable_limit: :infinity)

    :ok
  end

  def children,
    do: [
      Lytedev.HttpServer
    ]
end
