defmodule Lytedev.HttpServer do
  @moduledoc false

  require Logger

  @behaviour :elli_handler

  def child_spec(opts) do
    Logger.debug(inspect(opts))

    %{
      id: Lytedev.HttpServer,
      start: {:elli, :start_link, [[callback: Lytedev.HttpServer, port: port()]]}
    }
  end

  def handle(req, args) do
    Logger.debug(inspect(%{request: req, args: args}))
    {:ok, [], "Hello, World!"}
  end

  def handle_event(:elli_startup, _, _) do
    Logger.info("#{__MODULE__} started listening on port #{port()}.")
  end

  def handle_event(:request_error, data, args) do
    Logger.error(inspect({data, args}))
  end

  def handle_event(ev, data, args) do
    Logger.debug(inspect(%{event: ev, data: data, args: args}))
    :ok
  end

  defp config, do: Application.get_env(:lytedev, __MODULE__)
  defp port, do: config()[:port]
end
